<template lang="pug">
.page-cont
  .page-header(v-observe-visibility="visibilityChanged")
    .page-header__img
      .page-header__img-line
      img(v-if="hero_image" :src="hero_image" alt="")

    .container
      .page-header__go-back(v-if="hasPrevPage")
        span(
          @click="$router.back()"
        ) {{ $t('forms.buttons.back') }}

      h1.page-header__title(v-if="hero_title || title") {{ hero_title || title }}

  .contacts
    .container
      .contacts-header
        .contacts-header__title(
          v-if="slogan"
          v-html="slogan"
        )

        .contacts-header__tabs(v-if="branches.length")
          .contacts-header__tab(
            v-for="branch in branches"
            :key="branch.id"
          )
            .btn.btn--simple(
              :class="{ disabled: !activeBranch || activeBranch.id !== branch.id }"
              @click="changeBranch(branch)"
            ) {{ branch.title }}

      .contacts-cols
        .contacts-col.contacts-col--left
          .contacts__phone(v-if="activeBranch && activeBranch.phone")
            a(
              :href="activeBranch.phone | phoneUrl"
              @click="firePhoneClick(activeBranch.phone)"
            ) {{ activeBranch.phone }}

          .contacts__email(v-if="activeBranch && activeBranch.email")
            a(
              :href="`mailto:${activeBranch.email}`"
              @click="fireEmailClick(activeBranch.email, 'email')"
            ) {{ activeBranch.email }}

          socials(
            v-if="show_socials && menus.SOCIALS_MENU && menus.SOCIALS_MENU.items.length"
            classes="contacts__socials"
          )

        .contacts-col.contacts-col--right
          .map-container
            transition(name="fade")
              .contacts-address(
                v-if="activeBranch && activeBranch.address"
              )
                address(v-html="activeBranch.address")

            .contacts-map(v-observe-visibility="visibilityChanged")
              .contacts-map__lines
                span
                span

              transition(name="fade")

                  gmap-map(
                    v-if="mapCenter"
                    v-show="pageMounted"
                    :center="{ lat: activeBranch.map_lat, lng: activeBranch.map_lon }"
                    :zoom="mapZoom"
                    style="width: 100%; height: 100%; filter: grayscale(1)"
                    @map-was-initialized="mapInitialized"
                    :options="{zoomControl: false, mapTypeControl: false, scaleControl: false, streetViewControl: false, rotateControl: false, fullscreenControl: false, disableDefaultUi: true, clickableIcons: false}"
                    )
                      gmap-marker(
                        v-if="activeBranch"
                        :position="{ lat: activeBranch.map_lat, lng: activeBranch.map_lon }"
                        :icon="{url: `/images/map_pin-jetunity.svg`}"
                        style="image-offset: [-15, -4]; image-size: [30, 44]; filter: grayscale(0)"
                      )

              //- yandex-map(
                //-   v-if="mapCenter"
                //-   v-show="pageMounted"
                //-   :coords="mapCenter"
                //-   :zoom="mapZoom"
                //-   style="width: 100%; height: 100%;"
                //-   :scroll-zoom="false"
                //-   :controls="['zoomControl']"
                //-   @map-was-initialized="mapInitialized"
                //- )
                //-   ymap-marker(
                //-     v-if="activeBranch"
                //-     marker-id="1"
                //-     marker-type="placemark"
                //-     :coords="[activeBranch.map_lat, activeBranch.map_lon]"
                //-     :icon="iconOptions"
                //-   )
</template>

<script>
import { mapGetters } from 'vuex'
import API from '../api'
import { GmapMap } from 'vue2-google-maps'
import { pageMixin } from '@/mixins/pages'
import { visibilityMixin } from '@/mixins/visibility'
import { fetchPage } from '@/utils/asyncPages'
import { hasPrevPageMixin } from '@/mixins/has-prev-page'
import { phoneUrl } from '@/filters'
import { execMetrikaMethod } from '@/utils/metrika'
import config from '@/config'

export default {
  name: 'ContactsPage',

  async asyncData ({ app, error }) {
    return fetchPage(app, error, API.pages.contacts())
  },

  computed: {
    ...mapGetters({
      menus: 'vars/menus'
    }),
    iconOptions () {
      return {
        layout: 'default#image',
        imageHref: `/images/map_pin-${config.theme || 'jetunity'}.svg`,
        imageSize: [30, 44],
        imageOffset: [-15, -4]
      }
    }
  },

  data () {
    return {
      activeBranch: null,
      mapCenter: null,
      mapRef: null,
      mapZoom: 16,
      pageMounted: false
    }
  },

  filters: { phoneUrl },
  layout: 'white-header',

  methods: {
    changeBranch (branch) {
      this.activeBranch = branch
      this.mapCenter = [this.activeBranch.map_lat, this.activeBranch.map_lon]
      if (this.mapRef) {
        this.mapRef.setCenter(this.mapCenter, this.mapZoom)
      }
    },

    fireEmailClick (email, action) {
      execMetrikaMethod('reachGoal', [action])
    },

    firePhoneClick (phone) {
      let goal
      if (phone.indexOf('+7') === 0) {
        goal = 'tel-msk'
      } else {
        goal = 'tel-gb'
      }
      execMetrikaMethod('reachGoal', [goal])
    },

    mapInitialized (map) {
      this.mapRef = map
    }
  },

  mixins: [hasPrevPageMixin, pageMixin, visibilityMixin],

  mounted () {
    this.$nextTick(() => {
      this.pageMounted = true
    })
    if (this.branches.length) {
      this.changeBranch(this.branches[0])
    }
  }
}
</script>
